from typing import Callable, Generic, TypeVar

from ._mapper import Mapper

__all__ = ('CallableMapper',)

Element = TypeVar('Element')
Mapped = TypeVar('Mapped')


class CallableMapper(
    Mapper[Element, Mapped],
    Generic[Element, Mapped]
):
    def __init__(self, target: Callable[[Element], Mapped]):
        assert callable(target)
        self.target = target

    async def map(self, element: Element) -> Mapped:
        return self.target(element)
