from typing import Generic, TypeVar

from ._reduce import *

__all__ = ('PureReduce',)

Pure = TypeVar('Pure')


class PureReduce(Reduce[Pure, Pure], Generic[Pure]):
    def __init__(self, initial: Pure):
        super().__init__(initial)

    async def reduce(self, out: Pure, element: Pure) -> Pure:
        return self.merge(out, element)

    def merge(self, left: Pure, right: Pure) -> Pure:
        raise NotImplementedError
