from typing import Generic, TypeVar

from rainbowadn.flow.core import *
from ._verification import *

__all__ = ('MapperVerification',)

Verified = TypeVar('Verified')


class MapperVerification(Verification[Verified], Generic[Verified]):
    def __init__(self, mapper: Mapper[Verified, bool]):
        assert isinstance(mapper, Mapper)
        self.mapper = mapper

    async def verify(self, element: Verified) -> bool:
        return await self.mapper.map(element)
