from typing import Generic, TypeVar

from rainbowadn.core import *
from rainbowadn.flow.core import *

__all__ = ('ResolveMapper',)

MentionedT = TypeVar('MentionedT')
Out = TypeVar('Out')


class ResolveMapper(Mapper[HashPoint[MentionedT], MentionedT], Generic[MentionedT]):
    async def map(self, element: HashPoint[MentionedT]) -> MentionedT:
        return await element.resolve()

    def loose(self) -> Mapper[HashPoint[MentionedT], MentionedT]:
        return self

    @classmethod
    def wrap_mapper(cls, mapper: Mapper[MentionedT, Out]) -> Mapper[HashPoint[MentionedT], Out]:
        return Composition(cls().loose(), mapper)

    @classmethod
    def wrap_reducer(cls, reducer: Reducer[HashPoint[MentionedT], Out]) -> Reducer[MentionedT, Out]:
        return MapReducer(cls().loose(), reducer)
